Attribute VB_Name = "ZS6220"
'hCo[̎gp錾-----------------------------------------------------------------------------
Declare Function FT_OpenEx Lib "FTD2XX.DLL" (ByVal lpszArg1 As String, _
ByVal lngFlags As Long, ByRef lngHandle As Long) As Long
'-------------------------------------------------------------------------------------------------
Declare Function FT_Close Lib "FTD2XX.DLL" (ByVal lngHandle As Long) As Long
'-------------------------------------------------------------------------------------------------
Declare Function FT_Read Lib "FTD2XX.DLL" (ByVal lngHandle As Long, _
ByVal lpszBuffer As String, ByVal lngBufferSize As Long, ByRef lngBytesReturned As Long) As Long
'-------------------------------------------------------------------------------------------------
Declare Function FT_Write Lib "FTD2XX.DLL" (ByVal lngHandle As Long, _
ByVal lpszBuffer As String, ByVal lngBufferSize As Long, ByRef lngBytesWritten As Long) As Long
'-------------------------------------------------------------------------------------------------
Declare Function FT_SetBaudRate Lib "FTD2XX.DLL" (ByVal lngHandle As Long, _
ByVal lngBaudRate As Long) As Long
'-------------------------------------------------------------------------------------------------
Declare Function FT_SetDataCharacteristics Lib "FTD2XX.DLL" (ByVal lngHandle As Long, _
ByVal byWordLength As Byte, ByVal byStopBits As Byte, ByVal byParity As Byte) As Long
'-------------------------------------------------------------------------------------------------
Declare Function FT_SetFlowControl Lib "FTD2XX.DLL" (ByVal lngHandle As Long, _
ByVal intFlowControl As Integer, ByVal byXonChar As Byte, ByVal byXoffChar As Byte) As Long
'-------------------------------------------------------------------------------------------------
Declare Function FT_SetRts Lib "FTD2XX.DLL" (ByVal lngHandle As Long) As Long
'-------------------------------------------------------------------------------------------------
Declare Function FT_SetTimeouts Lib "FTD2XX.DLL" (ByVal lngHandle As Long, _
ByVal lngReadTimeout As Long, ByVal lngWriteTimeout As Long) As Long
'-------------------------------------------------------------------------------------------------
Declare Function FT_Purge Lib "FTD2XX.DLL" (ByVal lngHandle As Long, _
ByVal lngMask As Long) As Long
'-------------------------------------------------------------------------------------------------

Const FT_OK = 0
Const FT_OPEN_BY_SERIAL_NUMBER = 1
Const FT_BITS_8 = 8
Const FT_STOP_BITS_1 = 0
Const FT_PARITY_NONE = 0
Const FT_FLOW_RTS_CTS = &H100
Const FT_PURGE_RX = 1
Const FT_PURGE_TX = 2

Global Z_lngHandle As Long
Global Z_InByte As Long
Global Z_OutByte As Long

Function ZupOpen(Z_Serial As String, Z_IB As Long, Z_OB As Long, Z_TimeOut As Long) As Long
    Z_InByte = Z_IB * 2 + 2
    Z_OutByte = Z_OB * 2

    ZupOpen = FT_OpenEx(Z_Serial, FT_OPEN_BY_SERIAL_NUMBER, Z_lngHandle)
    If ZupOpen <> FT_OK Then
        FT_Close (Z_lngHandle)
        Exit Function
    End If
    
    ZupOpen = FT_SetBaudRate(Z_lngHandle, 230400)
    If ZupOpen <> FT_OK Then
        FT_Close (Z_lngHandle)
        Exit Function
    End If

    ZupOpen = FT_SetDataCharacteristics(Z_lngHandle, FT_BITS_8, FT_STOP_BITS_1, FT_PARITY_NONE)
    If ZupOpen <> FT_OK Then
        FT_Close (Z_lngHandle)
        Exit Function
    End If

    ZupOpen = FT_SetFlowControl(Z_lngHandle, FT_FLOW_RTS_CTS, 0, 0)
    If ZupOpen <> FT_OK Then
        FT_Close (Z_lngHandle)
        Exit Function
    End If

    ZupOpen = FT_SetRts(Z_lngHandle)
    If ZupOpen <> FT_OK Then
        FT_Close (Z_lngHandle)
        Exit Function
    End If
    
    ZupOpen = FT_SetTimeouts(Z_lngHandle, Z_TimeOut, Z_TimeOut)
    If ZupOpen <> FT_OK Then
        FT_Close (Z_lngHandle)
        Exit Function
    End If

    ZupOpen = FT_Purge(Z_lngHandle, FT_PURGE_RX)
    If ZupOpen <> FT_OK Then
        FT_Close (Z_lngHandle)
        Exit Function
    End If

    ZupOpen = FT_Purge(Z_lngHandle, FT_PURGE_TX)
    If ZupOpen <> FT_OK Then
        FT_Close (Z_lngHandle)
        Exit Function
    End If
End Function

Function ZupClose() As Long
    ZupClose = FT_Close(Z_lngHandle)
End Function

Function ZupRead(Buffer As String, Sync As Long) As Long
    Dim Ln As Long
    Dim R_Buf As String * 20
    
    If (Sync = 0) Then
        ZupRead = ZupWrite("S")
    End If

    ZupRead = FT_Read(Z_lngHandle, R_Buf, Z_InByte, Ln)
    If (ZupRead = FT_OK) Then
        If (Ln <> Z_InByte) Then
            ZupRead = 18
            Exit Function
        Else
            Buffer = R_Buf
        End If
    End If
End Function

Function ZupWrite(Buffer As String) As Long
    Dim wlen As Long, Ln As Long
    Dim W_Buf As String * 20
    
    wlen = Len(Buffer) + 2
    W_Buf = Buffer & vbCrLf

    Do
        DoEvents
        ZupWrite = FT_Write(Z_lngHandle, W_Buf, wlen, Ln)
    Loop While (ZupWrite <> FT_OK)
End Function

Function ZupTrigger() As Long
    ZupTrigger = ZupWrite("G")
End Function

Function ZupClear() As Long
    ZupClear = ZupWrite("L")
End Function
